"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const yargs_parser_1 = __importDefault(require("yargs-parser"));
function arrifyArgs(args) {
    const argsArray = [];
    for (const [key, val] of Object.entries(args)) {
        if (key === "--" && Array.isArray(val)) {
            val.forEach((arg) => argsArray.push(arg));
        }
        else if (Array.isArray(val)) {
            for (const item of val) {
                pushValue(key, item);
            }
        }
        else {
            pushValue(key, val);
        }
    }
    return argsArray;
    function pushValue(key, value) {
        let keyArg = "";
        if (typeof value === "boolean") {
            if (key.length === 1 && value) {
                keyArg = `-${key}`;
            }
            else if (value) {
                keyArg = `--${key}`;
            }
            else {
                keyArg = `--no-${key}`;
            }
            argsArray.push(keyArg);
        }
        else {
            if (key.length === 1 && value) {
                keyArg = `-${key}`;
            }
            else if (value) {
                keyArg = `--${key}`;
            }
            argsArray.push(keyArg, value);
        }
    }
}
exports.arrifyArgs = arrifyArgs;
function getPassThroughArgs(args) {
    let result = [];
    let { node: _nodeValues, scope: _scopeArg, since: _sinceArg, deps: _depsArg, cache: _cacheArg, ignore: _ignoreArg, _: _positionals } = args, filtered = __rest(args, ["node", "scope", "since", "deps", "cache", "ignore", "_"]);
    result = result.concat(arrifyArgs(filtered));
    return result;
}
exports.getPassThroughArgs = getPassThroughArgs;
function parseArgs() {
    return yargs_parser_1.default(process.argv.slice(2), {
        string: ["since"],
        array: ["scope", "node", "ignore"],
        configuration: {
            "populate--": true,
        },
    });
}
exports.parseArgs = parseArgs;
function validateInput(parsedArgs) {
    if (parsedArgs._.length < 1) {
        console.log("Usage: lage [command]");
        process.exit(0);
    }
}
exports.validateInput = validateInput;
